/*
 * Copyright (c) Atmosphère-NX
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once
#include <stratosphere/fs/fs_common.hpp>

namespace ams::fs {

    /* ACCURATE_TO_VERSION: Unknown */
    class IEventNotifier;

    struct EncryptionSeed {
        char value[0x10];
    };
    static_assert(util::is_pod<EncryptionSeed>::value);
    static_assert(sizeof(EncryptionSeed) == 0x10);

    Result MountSdCard(const char *name);

    Result MountSdCardErrorReportDirectoryForAtmosphere(const char *name);

    Result OpenSdCardDetectionEventNotifier(std::unique_ptr<IEventNotifier> *out);

    bool IsSdCardInserted();

}
