/*
 * Copyright (c) Atmosphère-NX
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once
#include <vapours.hpp>
#include <stratosphere/i2c.hpp>
#include <stratosphere/powctl/powctl_types.hpp>

namespace ams::powctl {

    /* Fuel Gauge. */
    constexpr inline const DeviceCode DeviceCode_Max17050 = i2c::DeviceCode_Max17050;

    /* Charger. */
    constexpr inline const DeviceCode DeviceCode_Bq24193  = i2c::DeviceCode_Bq24193;

}
