/*
 * Copyright (c) Atmosphère-NX
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <stratosphere.hpp>
#include "diag_abort_observer_manager.hpp"
#include "diag_invoke_abort.hpp"

namespace ams::diag::impl {

    extern bool g_enable_default_abort_observer;

    void DefaultAbortObserver(const AbortInfo &info);

    void InvokeAbortObserver(const AbortInfo &info) {
        if (g_enable_default_abort_observer) {
            DefaultAbortObserver(info);
        }

        GetAbortObserverManager()->InvokeAllObserver(info);
    }

    void InvokeSdkAbortObserver(const SdkAbortInfo &info) {
        GetSdkAbortObserverManager()->InvokeAllObserver(info);
    }

}
